#ifndef _BT_AC_H
#define _BT_AC_H

#include "array.h"

/*
 * This file defines shared functionality between different asset file cache
 * types such as the type cache and the global variable cache.
 */

struct bt_bf;

BT_ARRAY(cu);

typedef bool bt_ac_bf_process_cb_t(struct bt_bf *, const char *,
    BT_ARRAY(cu) *, void *);

/*
 * Process a file for the asset cache and use the provided resolver to also
 * process any object files used by the provided file.
 * If the third argument is non-NULL, then only CUs matching names in that
 * array will be processed.
 */
struct bt_so_resolver;
bool bt_ac_bf(struct bt_bf *, const char *, struct bt_so_resolver *,
    BT_ARRAY(cu) *, bt_ac_bf_process_cb_t *, void *);

/*
 * Function for use with CU iterators.  Filters CUs based on names included
 * in the second argument, which is treated as a cu bt_array.
 */
bool bt_ac_cu_filter(const char *, void *);

#endif /* endif */
