#ifndef BT_ERROR_H
#define BT_ERROR_H

#include <stdbool.h>

struct bt_error {
	const char *message;
	unsigned long long error;
};
typedef struct bt_error bt_error_t;

/*
 * Sets an error context to the specified string.
 */
static inline bool
_bt_error_set(struct bt_error *error, const char *message,
    unsigned long long n)
{

	error->message = message;
	error->error = n;
	return false;
}

#define bt_error_set(X, Y, ...) ({				\
	const char *_bte = (Y);					\
	unsigned long long _btn = __VA_ARGS__ - 0;		\
	_bt_error_set(X, _bte, _btn);				\
})

const char *bt_error_message(const bt_error_t *);

#endif /* BT_ERROR_H */
