#ifndef _BT_LUT_H
#define _BT_LUT_H

#include <stdbool.h>
#include <stddef.h>

struct bt_lut {
	void **value;
	unsigned int capacity;
};
typedef struct bt_lut bt_lut_t;

void bt_lut_deinit(bt_lut_t *);
bool bt_lut_init(bt_lut_t *, unsigned int);
bool bt_lut_grow(bt_lut_t *, unsigned int capacity);

static inline unsigned int
bt_lut_length(struct bt_lut *lut)
{

	return lut->capacity;
}

static inline bool
bt_lut_set(struct bt_lut *lut, unsigned int in, void *value)
{

	if (in >=lut->capacity &&
	    bt_lut_grow(lut, in) == false) {
		return false;
	}

	lut->value[in] = value;
	return true;
}

static inline bool
bt_lut_append(struct bt_lut *lut, void *value)
{

	return bt_lut_set(lut, bt_lut_length(lut), value);
}

static inline void *
bt_lut_get(struct bt_lut *lut, unsigned int in)
{

	if (in >= lut->capacity)
		return NULL;

	return lut->value[in];
}

#endif /* _BT_LUT_H */
